// , Ƽ ϳ  .
struct STidgetInfo
{
	wstring name;				// ڿ   . UI 
	wstring desc;				//    
	wstring cls;				//  Ҽ Ŭ.Ƽ  Ϸ ȣ ٿ id .
	bool allowMulti;			// Ƽ νϽ  . 
};

// Ƽ Ŭ. Ŭ   
class CTidget : public CDget
{
public:
	// Ŭ   . ϵ OnClick ϸ ȴ. 콺   Ϸ
	//  ڵ鷯 ϵ Ŭ  θ ޼带  ȣؾ Ѵ.
	LRESULT OnLButtonDown(WPARAM wParam, LPARAM lParam);
	LRESULT OnLButtonUp(WPARAM wParam, LPARAM lParam);
	virtual void OnClick() = 0;

	static CTidget* CreateObject(wstring cls);
	static CTidget* CreateDefaultObject(wstring cls);
	static CTidget* Deserialize(LPCTSTR pack);
	void Serialize(TCHAR* pack);
};

class CLCDTestWin : public CWindow
{
public:
	COLORREF arColor[8];
	int colorIdx;
	bool displayText;
	int nowMonitor;
	bool animate;
	int tileWidth;
	int aniIdx;
	int aniOffset;

	void Create(HWND hParent);
	LRESULT OnMessage(UINT iMessage, WPARAM wParam, LPARAM lParam);
	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnPaint(WPARAM wParam, LPARAM lParam);
	LRESULT OnKeyDown(WPARAM wParam, LPARAM lParam);
	LRESULT OnTimer(WPARAM wParam, LPARAM lParam);

	LRESULT RotateColor();
	LRESULT RotateMonitor();
};

class CLCDTest : public CTidget
{
public:
	HBITMAP icon;

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, int width, int height);
	void OnClick();
};

class CTextClip : public CTidget
{
public:
	HBITMAP bitOn, bitOff;
	bool clipToText;
	int clipCount;

	LRESULT OnMessage(UINT iMessage, WPARAM wParam, LPARAM lParam);
	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, int width, int height);
	void OnClick();
	void ClipboardTextOnly();
};

class CColorTableWin : public CWindow
{
public:
	HWND hList, hBtnCopy[4];
	enum { CT_LIST, CT_COPY1, CT_COPY2, CT_COPY3, CT_COPY4 };
	struct sOneColor
	{
		TCHAR name[32];
		COLORREF color;
	};
	sOneColor arColor[300];
	int colorCount;
	bool namedColor;
	int tile_width;
	int tile_height;
	int perLine;
	const int leftMargin = 150;
	int selIdx, prevSel;

	void Create(HWND hParent);
	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	LRESULT OnSize(WPARAM wParam, LPARAM lParam);
	LRESULT OnCommand(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, int width, int height);
	LRESULT OnLButtonDown(WPARAM wParam, LPARAM lParam);

	void PrepareColor(int colorType);
	static int colorNameCompare(const void* a, const void* b);
	void CalcTileSize();
	void ChangeSelColor(int idx);
};

class CColorTable : public CTidget
{
public:
	HBITMAP icon;

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, int width, int height);
	void OnClick();
};

class CMoveCursor : public CTidget
{
public:
	HBITMAP bitOn, bitOff;
	bool bCursorMove;			// Ŀ  ̵ 
	int TimerInterval;			// Ÿ̸ ֱ
	int CursorInterval;			// Ŀ  ̵ ֱ(ʴ)
	int CursorKeepSec;			// Ŀ  ʰ  ڸ ־ ð
	int RejectCount;			// Ŀ ̵ ȸ(ũ ̹  ȸ)
	POINT OldCursorPt;			//  Ŀ ġ

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, int width, int height);
	void OnClick();
	LRESULT OnTimer(WPARAM wParam, LPARAM lParam);
	LRESULT OnContextMenu(WPARAM wParam, LPARAM lParam);

	void LoadSetting();
	void SaveSetting();
	static INT_PTR CALLBACK MoveCursorDlgProc(HWND hDlg,
		UINT iMessage, WPARAM wParam, LPARAM lParam);
};

class CSizeMeter : public CTidget
{
public:
	HBITMAP icon;

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, int width, int height);
	void OnClick();
};

class CSizeMeterWin : public CWindow
{
public:
	void Create(HWND hParent);
	LRESULT OnSize(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, int width, int height);
	LRESULT OnKeyDown(WPARAM wParam, LPARAM lParam);
};

class CTetris : public CTidget
{
public:
	HBITMAP icon;

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, int width, int height);
	void OnClick();
};

class CTetrisWin : public CWindow
{
public:
	enum { EMPTY, BRICK, WALL = 7/*sizeof(Shape) / sizeof(Shape[0]) + 1*/ };
	int ts;
	int bw;
	int bh;
	unsigned char board[405][205];
	int nx, ny;
	int brick, rot;
	int nbrick;
	int score;
	int bricknum;
	int Interval;
	enum Status { GAMEOVER, RUNNING, PAUSE };
	Status GameStatus;
	HBRUSH arBrush[8];

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	LRESULT OnTimer(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, int width, int height);
	LRESULT OnKeyDown(WPARAM wParam, LPARAM lParam);

	void MakeNewBrick();
	int GetAround(int x, int y, int b, int r);
	BOOL MoveDown();
	void TestFull();
	void PrintTile(HDC hdc, int x, int y, int c);
	void AdjustMainWindow();
};

class CImageViewer;
class COneImage : public CTidget
{
public:
	TCHAR imagePath[MAX_PATH];
	Image* nowImage;
	HBITMAP icon;
	CImageViewer* pViewer;

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, int width, int height);
	void OnClick();
	LRESULT OnContextMenu(WPARAM wParam, LPARAM lParam);
	LRESULT OnUser1(WPARAM wParam, LPARAM lParam);
};

class CImageSlide;
class CImageViewer : public CWindow
{
public:
	int parentType;			//  θ. 0 = ̴, 1 = oneImage
	CDget* pParent;		// θ ü. Ʒ  ̸ ĳ д.
	CImageSlide* pSlide;
	COneImage* pOneImage;
	int nowIdx;						// ̴  ε
	TCHAR imagePath[MAX_PATH];		// OneImage ̹ 
	Image* nowImage;				// Ÿӿ ϴ ̹ ü
	bool fullScreen;
	WINDOWPLACEMENT prevWndPlace;

	void Create(int parentType, CDget* parent);
	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	LRESULT OnPaint(WPARAM wParam, LPARAM lParam);
	LRESULT OnSize(WPARAM wParam, LPARAM lParam);
	LRESULT OnKeyDown(WPARAM wParam, LPARAM lParam);
	LRESULT OnLButtonDblClk(WPARAM wParam, LPARAM lParam);
	LRESULT OnUser1(WPARAM wParam, LPARAM lParam);

	void toggleFullScreen();
};

class CEnumFont : public CTidget
{
public:
	HBITMAP icon;

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, int width, int height);
	void OnClick();
};

class CEnumFontWin : public CWindow
{
public:
	HWND hList, hChkAt, hChkSort, hStNum, hBtnApi, hEdApi, hBtnMfc, hEdMfc;
	enum { EF_LIST, EF_AT, EF_SORT, EF_NUM, EF_API, EF_EDAPI, EF_MFC, EF_EDMFC };
	static const int MAXFONT = 1000;
	LOGFONT arFont[CEnumFontWin::MAXFONT];
	int arFontType[CEnumFontWin::MAXFONT];
	int numFont;	// ߰ߵ Ʈ
	int nowFont;	//  Ʈ
	bool includeAt;	// @ Ʈ  

	LRESULT OnMessage(UINT iMessage, WPARAM wParam, LPARAM lParam);
	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, int width, int height);
	LRESULT OnCommand(WPARAM wParam, LPARAM lParam);

	void EnumFont();
	static int CALLBACK EnumFamCallBack(ENUMLOGFONT FAR* lpelf,
		NEWTEXTMETRIC FAR* lpntm, int FontType, LPARAM lParam);
	static int compareFace(const void* a, const void* b);
	void GetCharSetStr(int CharSet, TCHAR* str);
	void GetPitchFamStr(int Pitch, TCHAR* str);
	void SetCreateFontCommand();
};

class CSpy : public CTidget
{
public:
	HBITMAP icon;

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, int width, int height);
	void OnClick();
};

class CSpyWin : public CWindow
{
public:
	int TimerInterval;
	HWND hWndOld;
	HWND hEditInfo, hChkPause, hEditHier;
	enum { SPY_INFO, SPY_PAUSE, SPY_HIER };

	LRESULT OnMessage(UINT iMessage, WPARAM wParam, LPARAM lParam);
	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	LRESULT OnTimer(WPARAM wParam, LPARAM lParam);

	void GetStyleString(DWORD dwStyle, TCHAR* sStyle);
	void GetExStyleString(DWORD dwExStyle, TCHAR* sExStyle);
	static BOOL CALLBACK EnumChildProc(_In_ HWND hwnd, _In_ LPARAM lParam);
};
