// ũ Լ
#define Count(a) (sizeof(a)/sizeof(a[0]))
#define TextOutSz(h,x,y,t) TextOut(h,x,y,t,lstrlen(t));
#define ABS(a) ((a) >= 0 ? (a):-(a))
#define random(n) (rand()%(n))

// ƿƼ Լ 
void Trace(LPCTSTR format, ...);
void WriteLog(LPCTSTR strLog, ...);
void DrawBitmap(HDC hdc, int x, int y, HBITMAP hBit);
void StretchBitmap(HDC hdc, int x, int y, int w, int h, HBITMAP hBit);
void TextOutVCenter(HDC hdc, int x, int y, LPCTSTR str);
void FillRect(HDC hdc, int left, int top, int right, int bottom, HBRUSH brush);
void moveNext(int& now, int size);
void movePrev(int& now, int size);
bool IsTopMost(HWND hWnd);
void MySetImeMode(HWND hEdit, BOOL bHan);

struct SMonitorInfo {
	HMONITOR hMonitor;
	RECT rcMonitor;
	RECT rcWork;
	bool primary;
};
BOOL CALLBACK MonitorEnumProc(HMONITOR hMonitor, HDC hdcMonitor, LPRECT lprcMonitor, LPARAM dwData);
int GetMonitorOfWindow(HWND hWnd);

// Ÿ 
enum class eLang { KOR, ENG };

// GrpBtn Ÿ
#define GBS_PUSH 0
#define GBS_CHECK 1

// GrpBtn ޽
#define GBM_SETIMAGE WM_USER+1 
#define GBM_GETSTATE WM_USER+2
#define GBM_SETSTATE WM_USER+3

//  ޽
#define GBN_CLICKED 0

// ư  
enum eState { GB_NORMAL, GB_HOT, GB_DOWN, GB_DISABLE };
void ChangeState(HWND hWnd, eState State);

class CSetting
{
public:
	bool useIni;
	TCHAR iniPath[MAX_PATH];
	TCHAR regRoot[MAX_PATH];		//  \\ Ͽ    . 
	HKEY hive;

	//     Ѵ. Ʈ ο ̺    Ѵ.
	CSetting(bool useIni) {
		this->useIni = useIni;
		hive = HKEY_CURRENT_USER;
	}

	//    iniFile θ ʱȭѴ. 
	void SetIniPath(LPCTSTR filename);
	int get(wstring section, LPCTSTR key, int defValue);
	void get(wstring section, LPCTSTR key, LPCTSTR defValue, LPTSTR retValue, int nSize = 128);
	double getDouble(wstring section, LPCTSTR key, double defValue);

	bool set(wstring section, LPCTSTR key, int value);
	bool set(wstring section, LPCTSTR key, LPCTSTR value);
	bool setDouble(wstring section, LPCTSTR key, double value);

	void deleteSection(wstring section);
};

void EnsureVisible(HWND hWnd);

struct sNamedColor
{
	LPCTSTR name;
	COLORREF color;
};

COLORREF GetColorFromName(LPCTSTR name);
void MovePopupToSide(HWND hDlg, int wx, int wy);
int FindWidgetClsIdx(LPCTSTR cls);
int FindWidgetNameIdx(LPCTSTR name);
int FindTidgetNameIdx(LPCTSTR name);
int FindTidgetClsIdx(LPCTSTR cls);
DWORD MyGetAbsSecond(SYSTEMTIME st);
void MyAbsSecondToSystem(DWORD Abs, SYSTEMTIME& st);
void FixImageOrientation(Image* pImage);
void DrawImageCenter(HDC hdc, Image* pImage, int width, int height, bool erase, HBRUSH backBrush);
void makeFullScreen(HWND hWnd);

class CGdiPlusStarter
{
private:
	ULONG_PTR m_gpToken;

public:
	bool m_bSuccess;
	CGdiPlusStarter() {
		GdiplusStartupInput gpsi;
		m_bSuccess = (GdiplusStartup(&m_gpToken, &gpsi, NULL) == Ok);
	}
	~CGdiPlusStarter() {
		GdiplusShutdown(m_gpToken);
	}
};

void CopyClipboardText(LPCTSTR content);

template<typename T>
class TStack
{
protected:
	T* Stack;
	int Size;
	int Top;

public:
	TStack(int aSize) {
		Size = aSize;
		Stack = (T*)malloc(Size * sizeof(T));
		Top = -1;
	}
	virtual ~TStack() {
		free(Stack);
	}
	virtual BOOL Push(T data) {
		if (Top < Size - 1) {
			Top++;
			Stack[Top] = data;
			return TRUE;
		} else {
			return FALSE;
		}
	}
	virtual T Pop() {
		return Stack[Top--];
	}
	virtual int GetTop() { return Top; }
	virtual T GetValue(int n) { return Stack[n]; }
};

void TrimTrailZero(TCHAR* num);

// ׷ ũ   ڵ. GrpScr Ÿ
#define GSS_HORZ 1
#define GSS_VERT 2

// GrpScr ޽
#define GSM_SETRANGE WM_USER+1
#define GSM_GETRANGEHI WM_USER+2
#define GSM_GETRANGELOW WM_USER+3
#define GSM_SETPOS WM_USER+4
#define GSM_GETPOS WM_USER+5
#define GSM_SETTSIZE WM_USER+6
#define GSM_GETTSIZE WM_USER+7
#define GSM_SETTGAP WM_USER+8
#define GSM_GETTGAP WM_USER+9
#define GSM_SETBACKCOLOR WM_USER+10
#define GSM_SETTHUMBCOLOR WM_USER+11

void DrawOwnerItem(LPARAM lParam, sNamedColor arColor[]);
