// , Ƽ ϳ  .
struct SWidgetInfo
{
	wstring name;				// ڿ   . UI 
	wstring desc;				//    
	wstring cls;				//  Ҽ Ŭ.Ƽ  Ϸ ȣ ٿ id .
	bool allowMulti;			// Ƽ νϽ  . 
	int initHeight;				//  ġ  ʱ . 
	int initWidth;				//  ġ  ʱ ʺ
	COLORREF initColor;			// 
};

//  Ŭ.
class CWidget : public CDget
{
public:
	int vertHeight;					//   
	int horzWidth;					//   ʺ
	bool span;						// true̸    
	int spanRatio;					// ҷ.  ,  ȼ

	static CWidget* CreateObject(wstring cls);
	static CWidget* CreateDefaultObject(wstring cls);
	void Serialize(TCHAR* pack);
	static CWidget* Deserialize(LPCTSTR pack);
	static bool GetPackToken(LPCTSTR pack, int idx, TCHAR token[MAX_PATH]);
};

class CClock : public CWidget
{
public:
	int faceType;		// ð 
	bool hour24;		// 24ð ð ǥ
	bool outSec;		//  ǥ 
	bool digit2;		// ú 2ڸ
	int month, day;
	wstring yoil;
	int hour, min, sec;

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	LRESULT OnTimer(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, int width, int height);
	LRESULT OnContextMenu(WPARAM wParam, LPARAM lParam);

	void getRadialPos(int cx, int cy, int radius, double hour, int& x, int& y);
	void LoadSetting();
	void SaveSetting();
	static INT_PTR CALLBACK ClockDlgProc(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam);
};

class CRadix : public CWidget
{
public:
	HWND hEdit2;
	HWND hEdit10;
	HWND hEdit16;
	bool editByCode;

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnSize(WPARAM wParam, LPARAM lParam);
	LRESULT OnCommand(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, int width, int height);
};

class CCpuUsage : public CWidget
{
public:
	static const int USAGE_NUM = 60;
	double arUsage[USAGE_NUM];
	PDH_HQUERY cpuQuery;
	PDH_HCOUNTER cpuTotal;
	int timerInterval;
	bool varYAxis;
	bool viewThread;

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	LRESULT OnTimer(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, int width, int height);
	LRESULT OnContextMenu(WPARAM wParam, LPARAM lParam);

	void LoadSetting();
	void SaveSetting();
	static INT_PTR CALLBACK CpuUsageDlgProc(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam);
};

class CMemUsage : public CWidget
{
public:
	int timerInterval;
	MEMORYSTATUSEX mem;

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	LRESULT OnTimer(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, int width, int height);
};

class CBattery : public CWidget
{
public:
	SYSTEM_POWER_STATUS sps;

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	LRESULT OnTimer(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, int width, int height);
};

class CDiskUsage : public CWidget
{
public:
	struct DiskInfo
	{
		TCHAR drive;
		ULARGE_INTEGER Avail, Total, Free;
	};

	int timerInterval;
	DiskInfo arDisk[26];
	bool includeRemovable;
	bool includeNetwork;
	bool relativeChart;

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	LRESULT OnTimer(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, int width, int height);
	LRESULT OnContextMenu(WPARAM wParam, LPARAM lParam);

	void LoadSetting();
	void SaveSetting();
	static INT_PTR CALLBACK DiskUsageDlgProc(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam);
};

class CCalc : public CWidget
{
public:
	HWND hCbExp;
	HWND hEdit;
	HWND hBtnCopy;
	double calcResult;
	TCHAR sResult[128];
	bool autoCopy;
	static WNDPROC CalcOldEditProc;

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnSize(WPARAM wParam, LPARAM lParam);
	LRESULT OnCommand(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, int width, int height);
	LRESULT OnContextMenu(WPARAM wParam, LPARAM lParam);
	LRESULT OnUser1(WPARAM wParam, LPARAM lParam);
	LRESULT OnUser2(WPARAM wParam, LPARAM lParam);

	double CalcExp(TCHAR* exp, BOOL* bError/*=NULL*/);
	double CalcPostfix(TCHAR* Post);
	void MakePostfix(TCHAR* Post, TCHAR* Mid);
	int GetPriority(int op);
	bool isCalcChar(TCHAR c);
	static LRESULT CALLBACK EditProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam);
	void CopyResult();
};

class CMusicPlayer : public CWidget
{
public:
	HWND hPlay, hStop, hPrev, hNext;
	HWND hProg, hList;
	HWND hGroup1, hGroup2, hGroup3, hGroup4;
	HWND hAdd, hClear, hRandom;
	enum {
		MP_PLAY, MP_STOP, MP_PREV, MP_NEXT, MP_PROG,
		MP_LIST, MP_GROUP1, MP_GROUP2, MP_GROUP3, MP_GROUP4,
		MP_ADD, MP_CLEAR, MP_RANDOM
	};
	// Ÿ̸ . 1   1ȸ
	enum {
		MPTM_PROG = 1,			// α׷ ſ
		MPTM_PLAYACTIVE,		//  Ŀ   
		MPTM_PLAYNEXT,			//  ׷  
		MPTM_PLAYPREV,			//  ׷  
		MPTM_MOVEPOS,			//   ġ ̵
	};

	vector<wstring> arMusic[4];	//  
	int playGroup;				//   ׷
	int playIdx;				//   playGroup 
	int groupIdx[4];			//  ׷ 
	bool randomPlay;			//  
	UINT dev_id;				// MCI ġ. 0̸  ƴ
	TCHAR stripPath[MAX_PATH];	// ID3 ±׸  ӽ  

	LRESULT OnMessage(UINT iMessage, WPARAM wParam, LPARAM lParam);
	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	LRESULT OnSize(WPARAM wParam, LPARAM lParam);
	LRESULT OnTimer(WPARAM wParam, LPARAM lParam);
	LRESULT OnContextMenu(WPARAM wParam, LPARAM lParam);
	LRESULT OnDropFiles(WPARAM wParam, LPARAM lParam);
	LRESULT OnCommand(WPARAM wParam, LPARAM lParam);

	void PlayActiveCurrent();
	bool DoPlayCurrent(bool bNext);
	bool DoPlay(LPCTSTR musicPath, int fromPos = 0);
	DWORD GetStatus();
	DWORD GetPosition();
	DWORD GetLength();
	bool AddFile(LPCTSTR Path);
	void LoadMusicList();
	void SaveMusicList();
	void FillListBox(int group);
	void ChangeActiveGroup(int group, bool init = false);
	int GetActiveGroup();
	int SelectRandomPlay();
	bool StripID3Tag(LPCTSTR path);
};

class CImageViewer;
class CImageSlide : public CWidget
{
public:
	int timerInterval;
	int nowIdx;
	Image* nowImage;
	vector<wstring> arImage;
	bool randomSlide;				//  
	bool displayFileName;			// ϸ ǥ
	bool multiViewer;				// Ŭ    ϳ 
	CImageViewer* pLastViewer;

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	LRESULT OnTimer(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, int width, int height);
	LRESULT OnLButtonDown(WPARAM wParam, LPARAM lParam);
	LRESULT OnUser1(WPARAM wParam, LPARAM lParam);
	LRESULT OnDropFiles(WPARAM wParam, LPARAM lParam);
	LRESULT OnContextMenu(WPARAM wParam, LPARAM lParam);

	void LoadSetting();
	void SaveSetting();
	void LoadImageList();
	void SaveImageList();
	static INT_PTR CALLBACK ImageSlideDlgProc(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam);
};

class CMemoViewer;
class CMemo : public CWidget
{
public:
	HWND hCombo, hAdd, hDelete, hView, hEdit;
	enum {
		MEMO_COMBO, MEMO_ADD, MEMO_DELETE, MEMO_VIEW, MEMO_EDIT
	};

	struct sMemo {
		TCHAR title[64];				// 
		int x, y, w, h;					//  ġ, ũ
		COLORREF foreColor, backColor;	// , 
		bool isText;					// ؽƮ Ǵ Ĺ
		TCHAR fontFace[32];				// Ʈ.
		int fontSize;					// Ʈ ũ
		bool wordWrap;					// ڵ  
		TCHAR* content;					// 
		int content_len;				//  
		bool isModi;					//  
		CMemoViewer* pViewer;			//  ü.    NULL
	};

	vector<sMemo*> arMemo;
	int nowIdx;
	bool isModi;				// ޸ ϳ ٲ ִ 

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	LRESULT OnSize(WPARAM wParam, LPARAM lParam);
	LRESULT OnCommand(WPARAM wParam, LPARAM lParam);
	LRESULT OnUser1(WPARAM wParam, LPARAM lParam);

	void SaveMemo(int idx);
	void SaveMemo(sMemo* pMemo, HWND hEdit);
	void SaveMemoList();
	void LoadMemoList();
	void GetMemoFilePath(TCHAR* Path);
};

class CMemoViewer : public CWindow
{
public:
	CMemo* pMemoWidget;
	int nowIdx;
	CMemo::sMemo* pMemo;
	bool isModi;
	HWND hClose, hAttr, hEdit;
	enum { MV_CLOSE, MV_ATTR, MV_EDIT };
	HFONT fontEdit;
	HBRUSH backBrush;
	bool destroyBySelf;

	void Create(CMemo* pMemoWidget, int idx);
	LRESULT OnMessage(UINT iMessage, WPARAM wParam, LPARAM lParam);
	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	LRESULT OnSize(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, int width, int height);
	LRESULT OnCommand(WPARAM wParam, LPARAM lParam);

	void SendMemoToWidget();
	void RefreshMemo();
};

class CDday : public CWidget
{
public:
	wstring targetTitle;
	SYSTEMTIME targetDate;
	TCHAR remain[128];
	TCHAR remainOld[128];
	bool displayHour;
	bool displayMinute;

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	LRESULT OnTimer(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, int width, int height);
	LRESULT OnContextMenu(WPARAM wParam, LPARAM lParam);

	void LoadSetting();
	void SaveSetting();
	static INT_PTR CALLBACK DdayDlgProc(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam);
};


